'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var http = require('http');
var URL = require('url-parse');
var formurlencoded = require('form-urlencoded');
var request = require('request');
var port = 3001;

var config = require('./config');

module.exports = function (code_verifier) {
  return new Promise(function (resolve, reject) {
    var server = http.createServer(function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res) {
        var url, _url$query, code, state, options;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                url = new URL(req.url, true);
                _url$query = url.query, code = _url$query.code, state = _url$query.state;

                //     curl --request POST \
                // --url https://dev-665774.oktapreview.com/oauth2/default/v1/token \
                // --header 'accept: application/json' \
                // --header 'cache-control: no-cache' \
                // --header 'content-type: application/x-www-form-urlencoded' \
                // --data 'grant_type=authorization_code&client_id=0oabygpxgk9lXaMgF0h7&redirect
                // _uri=yourApp%3A%2Fcallback&code=CKA9Utz2GkWlsrmnqehz&code_verifier=M25iVXpKU
                // 3puUjFaYWg3T1NDTDQtcW1ROUY5YXlwalNoc0hhakxifmZHag'

                options = {
                  method: 'POST',
                  url: 'https://' + config.okta_host + '/oauth2/default/v1/token',
                  headers: {
                    accept: 'application/json',
                    'cache-control': 'no-cache',
                    'content-type': 'application/x-www-form-urlencoded'
                  },
                  body: formurlencoded({
                    grant_type: 'authorization_code',
                    client_id: config.client_id,
                    code_verifier: code_verifier,
                    code: code,
                    redirect_uri: config.redirect_uri
                  })
                };


                request(options, function (error, resp, body) {
                  if (error) throw new Error(error);

                  res.end('\n        <!DOCTYPE html>\n        <html>\n          <head>\n            <meta charset="UTF-8">\n            <title>Transmute CLI Login</title>\n            <style>\n            body {\n              margin: 0;\n              padding: 0;\n              font-family: sans-serif;\n              background-image: url("https://source.unsplash.com/random/1280x1024");\n              background-size: cover;\n              height: 100%;\n            }\n            </style>\n          </head>\n          <body>\n          <p>You are now logged in the transmute cli...</p>\n        <p>You can safely close this tab</p>\n          </body>\n        </html>\n        ');

                  resolve(JSON.parse(body));
                });

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, undefined);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());

    server.listen(port, function (err) {
      if (err) {
        return console.log('something bad happened', err);
        reject(err);
      }
      console.log('server is listening on ' + port);
    });
  });
};