'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var crypto = require('crypto');

var path = require('path');

var callbackServer = require('./callbackServer');

var config = require('./config');

var fse = require('fs-extra');

var writeFile = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(filePath, fileData) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', new Promise(function (resolve, reject) {
              fse.outputFile(filePath, fileData, function (err) {
                if (err) {
                  reject(err);
                }
                resolve(true);
              });
            }));

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function writeFile(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

function base64URLEncode(str) {
  return str.toString('base64').replace(/\+/g, '-').replace(/\//g, '_').replace(/=/g, '');
}

function sha256(buffer) {
  return crypto.createHash('sha256').update(buffer).digest();
}

/**
 * This session object is returned from the okta authentication process.
 * @name okta_session_object
 * @param {Object} session - returned from the okta auth process.
 * @param {string} session.access_token - A signed but not encrypted JWT 
 * @param {string} session.token_type - Usually 'Bearer'
 * @param {string} session.expires_in - Expiration in seconds
 * @param {string} session.scope - Usually 'openid'
 * @param {string} session.id_token - A signed but not encrypted JWT
 */

/**
 * login with okta
 * @description This method crafts an authentication url, and then starts an http server to listen for the redirect from the authentication.
 * @return {okta_session_object} A session object with access_token and id_token.
 */
var login = exports.login = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var okta_host, redirect_uri, client_id, code_verifier, code_challenge, url, response, home;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            okta_host = config.okta_host, redirect_uri = config.redirect_uri, client_id = config.client_id;
            code_verifier = base64URLEncode(crypto.randomBytes(32));
            code_challenge = base64URLEncode(sha256(code_verifier));
            url = 'https://' + okta_host + '/oauth2/default/v1/authorize?client_id=' + client_id + '&response_type=code&scope=openid&redirect_uri=' + redirect_uri + '&state=state-8600b31f-52d1-4dca-987c-386e3d8967e9&code_challenge_method=S256&code_challenge=' + code_challenge;


            console.log('open this url: \n');
            console.log(url);
            console.log();

            _context2.next = 9;
            return callbackServer(code_verifier);

          case 9:
            response = _context2.sent;
            home = require('os').homedir();
            _context2.next = 13;
            return writeFile(path.join(home, '.transmute/cli-secrets/session.json'), JSON.stringify(response, null, 2));

          case 13:
            return _context2.abrupt('return', response);

          case 14:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function login() {
    return _ref2.apply(this, arguments);
  };
}();