'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var crypto = require('crypto');

var shell = require('shelljs');

var callbackServer = require('./callbackServer');

var config = require('./config');

function base64URLEncode(str) {
  return str.toString('base64').replace(/\+/g, '-').replace(/\//g, '_').replace(/=/g, '');
}

function sha256(buffer) {
  return crypto.createHash('sha256').update(buffer).digest();
}

module.exports = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
  var okta_host, redirect_uri, client_id, code_verifier, code_challenge, url;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          okta_host = config.okta_host, redirect_uri = config.redirect_uri, client_id = config.client_id;
          code_verifier = base64URLEncode(crypto.randomBytes(32));
          code_challenge = base64URLEncode(sha256(code_verifier));
          url = 'https://' + okta_host + '/oauth2/default/v1/authorize?client_id=' + client_id + '&response_type=code&scope=openid&redirect_uri=' + redirect_uri + '&state=state-8600b31f-52d1-4dca-987c-386e3d8967e9&code_challenge_method=S256&code_challenge=' + code_challenge;


          console.log('open this url: ');
          console.log(url);
          // const command = `open "${url}"`;
          // const execution = shell.exec(command);
          // if (execution.code !== 0) {
          //   shell.exit(1);
          // }
          return _context.abrupt('return', callbackServer(code_verifier));

        case 7:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, undefined);
}));